# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['PreventionPolicyLinuxArgs', 'PreventionPolicyLinux']

@pulumi.input_type
class PreventionPolicyLinuxArgs:
    def __init__(__self__, *,
                 cloud_anti_malware: Optional[pulumi.Input['PreventionPolicyLinuxCloudAntiMalwareArgs']] = None,
                 custom_blocking: Optional[pulumi.Input[bool]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 drift_prevention: Optional[pulumi.Input[bool]] = None,
                 email_protocol_visibility: Optional[pulumi.Input[bool]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 filesystem_visibility: Optional[pulumi.Input[bool]] = None,
                 ftp_visibility: Optional[pulumi.Input[bool]] = None,
                 host_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 http_visibility: Optional[pulumi.Input[bool]] = None,
                 ioa_rule_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network_visibility: Optional[pulumi.Input[bool]] = None,
                 prevent_suspicious_processes: Optional[pulumi.Input[bool]] = None,
                 quarantine: Optional[pulumi.Input[bool]] = None,
                 script_based_execution_monitoring: Optional[pulumi.Input[bool]] = None,
                 sensor_anti_malware: Optional[pulumi.Input['PreventionPolicyLinuxSensorAntiMalwareArgs']] = None,
                 tls_visibility: Optional[pulumi.Input[bool]] = None,
                 upload_unknown_detection_related_executables: Optional[pulumi.Input[bool]] = None,
                 upload_unknown_executables: Optional[pulumi.Input[bool]] = None):
        """
        The set of arguments for constructing a PreventionPolicyLinux resource.
        :param pulumi.Input['PreventionPolicyLinuxCloudAntiMalwareArgs'] cloud_anti_malware: Use cloud-based machine learning informed by global analysis of executables to detect and prevent known malware for your online hosts.
        :param pulumi.Input[bool] custom_blocking: Whether to enable the setting. Block processes matching hashes that you add to IOC Management with the action set to "Block" or "Block, hide detection".
        :param pulumi.Input[str] description: Description of the prevention policy.
        :param pulumi.Input[bool] drift_prevention: Whether to enable the setting. Block new processes originating from files written in a container. This prevents a container from drifting from its immutable runtime state.
        :param pulumi.Input[bool] email_protocol_visibility: Whether to enable the setting. Allows the sensor to monitor SMTP, IMAP, and POP3 traffic for malicious patterns and improved detections.
        :param pulumi.Input[bool] enabled: Enable the prevention policy.
        :param pulumi.Input[bool] filesystem_visibility: Whether to enable the setting. Allows the sensor to monitor filesystem activity for additional telemetry and improved detections.
        :param pulumi.Input[bool] ftp_visibility: Whether to enable the setting. Allows the sensor to monitor unencrypted FTP traffic for malicious patterns and improved detections.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_groups: Host Group ids to attach to the prevention policy.
        :param pulumi.Input[bool] http_visibility: Whether to enable the setting. Allows the sensor to monitor unencrypted HTTP traffic for malicious patterns and improved detections.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ioa_rule_groups: IOA Rule Group to attach to the prevention policy.
        :param pulumi.Input[str] name: Name of the prevention policy.
        :param pulumi.Input[bool] network_visibility: Whether to enable the setting. Allows the sensor to monitor network activity for additional telemetry and improved detections.
        :param pulumi.Input[bool] prevent_suspicious_processes: Whether to enable the setting. Block processes that CrowdStrike analysts classify as suspicious. These are focused on dynamic IOAs, such as malware, exploits and other threats.
        :param pulumi.Input[bool] quarantine: Whether to enable the setting. Quarantine executable files after they’re prevented by NGAV. When this is enabled, we recommend setting anti-malware prevention levels to Moderate or higher and not using other antivirus solutions.
        :param pulumi.Input[bool] script_based_execution_monitoring: Whether to enable the setting. Provides visibility into suspicious scripts, including shell and other scripting languages.
        :param pulumi.Input['PreventionPolicyLinuxSensorAntiMalwareArgs'] sensor_anti_malware: For offline and online hosts, use sensor-based machine learning to identify and analyze unknown executables as they run to detect and prevent malware.
        :param pulumi.Input[bool] tls_visibility: Whether to enable the setting. Allows the sensor to monitor TLS traffic for malicious patterns and improved detections.
        :param pulumi.Input[bool] upload_unknown_detection_related_executables: Whether to enable the setting. Upload all unknown detection-related executables for advanced analysis in the cloud.
        :param pulumi.Input[bool] upload_unknown_executables: Whether to enable the setting. Upload all unknown executables for advanced analysis in the cloud.
        """
        if cloud_anti_malware is not None:
            pulumi.set(__self__, "cloud_anti_malware", cloud_anti_malware)
        if custom_blocking is not None:
            pulumi.set(__self__, "custom_blocking", custom_blocking)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if drift_prevention is not None:
            pulumi.set(__self__, "drift_prevention", drift_prevention)
        if email_protocol_visibility is not None:
            pulumi.set(__self__, "email_protocol_visibility", email_protocol_visibility)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if filesystem_visibility is not None:
            pulumi.set(__self__, "filesystem_visibility", filesystem_visibility)
        if ftp_visibility is not None:
            pulumi.set(__self__, "ftp_visibility", ftp_visibility)
        if host_groups is not None:
            pulumi.set(__self__, "host_groups", host_groups)
        if http_visibility is not None:
            pulumi.set(__self__, "http_visibility", http_visibility)
        if ioa_rule_groups is not None:
            pulumi.set(__self__, "ioa_rule_groups", ioa_rule_groups)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if network_visibility is not None:
            pulumi.set(__self__, "network_visibility", network_visibility)
        if prevent_suspicious_processes is not None:
            pulumi.set(__self__, "prevent_suspicious_processes", prevent_suspicious_processes)
        if quarantine is not None:
            pulumi.set(__self__, "quarantine", quarantine)
        if script_based_execution_monitoring is not None:
            pulumi.set(__self__, "script_based_execution_monitoring", script_based_execution_monitoring)
        if sensor_anti_malware is not None:
            pulumi.set(__self__, "sensor_anti_malware", sensor_anti_malware)
        if tls_visibility is not None:
            pulumi.set(__self__, "tls_visibility", tls_visibility)
        if upload_unknown_detection_related_executables is not None:
            pulumi.set(__self__, "upload_unknown_detection_related_executables", upload_unknown_detection_related_executables)
        if upload_unknown_executables is not None:
            pulumi.set(__self__, "upload_unknown_executables", upload_unknown_executables)

    @property
    @pulumi.getter(name="cloudAntiMalware")
    def cloud_anti_malware(self) -> Optional[pulumi.Input['PreventionPolicyLinuxCloudAntiMalwareArgs']]:
        """
        Use cloud-based machine learning informed by global analysis of executables to detect and prevent known malware for your online hosts.
        """
        return pulumi.get(self, "cloud_anti_malware")

    @cloud_anti_malware.setter
    def cloud_anti_malware(self, value: Optional[pulumi.Input['PreventionPolicyLinuxCloudAntiMalwareArgs']]):
        pulumi.set(self, "cloud_anti_malware", value)

    @property
    @pulumi.getter(name="customBlocking")
    def custom_blocking(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Block processes matching hashes that you add to IOC Management with the action set to "Block" or "Block, hide detection".
        """
        return pulumi.get(self, "custom_blocking")

    @custom_blocking.setter
    def custom_blocking(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "custom_blocking", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of the prevention policy.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="driftPrevention")
    def drift_prevention(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Block new processes originating from files written in a container. This prevents a container from drifting from its immutable runtime state.
        """
        return pulumi.get(self, "drift_prevention")

    @drift_prevention.setter
    def drift_prevention(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "drift_prevention", value)

    @property
    @pulumi.getter(name="emailProtocolVisibility")
    def email_protocol_visibility(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Allows the sensor to monitor SMTP, IMAP, and POP3 traffic for malicious patterns and improved detections.
        """
        return pulumi.get(self, "email_protocol_visibility")

    @email_protocol_visibility.setter
    def email_protocol_visibility(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "email_protocol_visibility", value)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Enable the prevention policy.
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter(name="filesystemVisibility")
    def filesystem_visibility(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Allows the sensor to monitor filesystem activity for additional telemetry and improved detections.
        """
        return pulumi.get(self, "filesystem_visibility")

    @filesystem_visibility.setter
    def filesystem_visibility(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "filesystem_visibility", value)

    @property
    @pulumi.getter(name="ftpVisibility")
    def ftp_visibility(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Allows the sensor to monitor unencrypted FTP traffic for malicious patterns and improved detections.
        """
        return pulumi.get(self, "ftp_visibility")

    @ftp_visibility.setter
    def ftp_visibility(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ftp_visibility", value)

    @property
    @pulumi.getter(name="hostGroups")
    def host_groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Host Group ids to attach to the prevention policy.
        """
        return pulumi.get(self, "host_groups")

    @host_groups.setter
    def host_groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "host_groups", value)

    @property
    @pulumi.getter(name="httpVisibility")
    def http_visibility(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Allows the sensor to monitor unencrypted HTTP traffic for malicious patterns and improved detections.
        """
        return pulumi.get(self, "http_visibility")

    @http_visibility.setter
    def http_visibility(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "http_visibility", value)

    @property
    @pulumi.getter(name="ioaRuleGroups")
    def ioa_rule_groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        IOA Rule Group to attach to the prevention policy.
        """
        return pulumi.get(self, "ioa_rule_groups")

    @ioa_rule_groups.setter
    def ioa_rule_groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "ioa_rule_groups", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the prevention policy.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="networkVisibility")
    def network_visibility(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Allows the sensor to monitor network activity for additional telemetry and improved detections.
        """
        return pulumi.get(self, "network_visibility")

    @network_visibility.setter
    def network_visibility(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "network_visibility", value)

    @property
    @pulumi.getter(name="preventSuspiciousProcesses")
    def prevent_suspicious_processes(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Block processes that CrowdStrike analysts classify as suspicious. These are focused on dynamic IOAs, such as malware, exploits and other threats.
        """
        return pulumi.get(self, "prevent_suspicious_processes")

    @prevent_suspicious_processes.setter
    def prevent_suspicious_processes(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "prevent_suspicious_processes", value)

    @property
    @pulumi.getter
    def quarantine(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Quarantine executable files after they’re prevented by NGAV. When this is enabled, we recommend setting anti-malware prevention levels to Moderate or higher and not using other antivirus solutions.
        """
        return pulumi.get(self, "quarantine")

    @quarantine.setter
    def quarantine(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "quarantine", value)

    @property
    @pulumi.getter(name="scriptBasedExecutionMonitoring")
    def script_based_execution_monitoring(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Provides visibility into suspicious scripts, including shell and other scripting languages.
        """
        return pulumi.get(self, "script_based_execution_monitoring")

    @script_based_execution_monitoring.setter
    def script_based_execution_monitoring(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "script_based_execution_monitoring", value)

    @property
    @pulumi.getter(name="sensorAntiMalware")
    def sensor_anti_malware(self) -> Optional[pulumi.Input['PreventionPolicyLinuxSensorAntiMalwareArgs']]:
        """
        For offline and online hosts, use sensor-based machine learning to identify and analyze unknown executables as they run to detect and prevent malware.
        """
        return pulumi.get(self, "sensor_anti_malware")

    @sensor_anti_malware.setter
    def sensor_anti_malware(self, value: Optional[pulumi.Input['PreventionPolicyLinuxSensorAntiMalwareArgs']]):
        pulumi.set(self, "sensor_anti_malware", value)

    @property
    @pulumi.getter(name="tlsVisibility")
    def tls_visibility(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Allows the sensor to monitor TLS traffic for malicious patterns and improved detections.
        """
        return pulumi.get(self, "tls_visibility")

    @tls_visibility.setter
    def tls_visibility(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "tls_visibility", value)

    @property
    @pulumi.getter(name="uploadUnknownDetectionRelatedExecutables")
    def upload_unknown_detection_related_executables(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Upload all unknown detection-related executables for advanced analysis in the cloud.
        """
        return pulumi.get(self, "upload_unknown_detection_related_executables")

    @upload_unknown_detection_related_executables.setter
    def upload_unknown_detection_related_executables(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "upload_unknown_detection_related_executables", value)

    @property
    @pulumi.getter(name="uploadUnknownExecutables")
    def upload_unknown_executables(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Upload all unknown executables for advanced analysis in the cloud.
        """
        return pulumi.get(self, "upload_unknown_executables")

    @upload_unknown_executables.setter
    def upload_unknown_executables(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "upload_unknown_executables", value)


@pulumi.input_type
class _PreventionPolicyLinuxState:
    def __init__(__self__, *,
                 cloud_anti_malware: Optional[pulumi.Input['PreventionPolicyLinuxCloudAntiMalwareArgs']] = None,
                 custom_blocking: Optional[pulumi.Input[bool]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 drift_prevention: Optional[pulumi.Input[bool]] = None,
                 email_protocol_visibility: Optional[pulumi.Input[bool]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 filesystem_visibility: Optional[pulumi.Input[bool]] = None,
                 ftp_visibility: Optional[pulumi.Input[bool]] = None,
                 host_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 http_visibility: Optional[pulumi.Input[bool]] = None,
                 ioa_rule_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 last_updated: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network_visibility: Optional[pulumi.Input[bool]] = None,
                 prevent_suspicious_processes: Optional[pulumi.Input[bool]] = None,
                 quarantine: Optional[pulumi.Input[bool]] = None,
                 script_based_execution_monitoring: Optional[pulumi.Input[bool]] = None,
                 sensor_anti_malware: Optional[pulumi.Input['PreventionPolicyLinuxSensorAntiMalwareArgs']] = None,
                 tls_visibility: Optional[pulumi.Input[bool]] = None,
                 upload_unknown_detection_related_executables: Optional[pulumi.Input[bool]] = None,
                 upload_unknown_executables: Optional[pulumi.Input[bool]] = None):
        """
        Input properties used for looking up and filtering PreventionPolicyLinux resources.
        :param pulumi.Input['PreventionPolicyLinuxCloudAntiMalwareArgs'] cloud_anti_malware: Use cloud-based machine learning informed by global analysis of executables to detect and prevent known malware for your online hosts.
        :param pulumi.Input[bool] custom_blocking: Whether to enable the setting. Block processes matching hashes that you add to IOC Management with the action set to "Block" or "Block, hide detection".
        :param pulumi.Input[str] description: Description of the prevention policy.
        :param pulumi.Input[bool] drift_prevention: Whether to enable the setting. Block new processes originating from files written in a container. This prevents a container from drifting from its immutable runtime state.
        :param pulumi.Input[bool] email_protocol_visibility: Whether to enable the setting. Allows the sensor to monitor SMTP, IMAP, and POP3 traffic for malicious patterns and improved detections.
        :param pulumi.Input[bool] enabled: Enable the prevention policy.
        :param pulumi.Input[bool] filesystem_visibility: Whether to enable the setting. Allows the sensor to monitor filesystem activity for additional telemetry and improved detections.
        :param pulumi.Input[bool] ftp_visibility: Whether to enable the setting. Allows the sensor to monitor unencrypted FTP traffic for malicious patterns and improved detections.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_groups: Host Group ids to attach to the prevention policy.
        :param pulumi.Input[bool] http_visibility: Whether to enable the setting. Allows the sensor to monitor unencrypted HTTP traffic for malicious patterns and improved detections.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ioa_rule_groups: IOA Rule Group to attach to the prevention policy.
        :param pulumi.Input[str] name: Name of the prevention policy.
        :param pulumi.Input[bool] network_visibility: Whether to enable the setting. Allows the sensor to monitor network activity for additional telemetry and improved detections.
        :param pulumi.Input[bool] prevent_suspicious_processes: Whether to enable the setting. Block processes that CrowdStrike analysts classify as suspicious. These are focused on dynamic IOAs, such as malware, exploits and other threats.
        :param pulumi.Input[bool] quarantine: Whether to enable the setting. Quarantine executable files after they’re prevented by NGAV. When this is enabled, we recommend setting anti-malware prevention levels to Moderate or higher and not using other antivirus solutions.
        :param pulumi.Input[bool] script_based_execution_monitoring: Whether to enable the setting. Provides visibility into suspicious scripts, including shell and other scripting languages.
        :param pulumi.Input['PreventionPolicyLinuxSensorAntiMalwareArgs'] sensor_anti_malware: For offline and online hosts, use sensor-based machine learning to identify and analyze unknown executables as they run to detect and prevent malware.
        :param pulumi.Input[bool] tls_visibility: Whether to enable the setting. Allows the sensor to monitor TLS traffic for malicious patterns and improved detections.
        :param pulumi.Input[bool] upload_unknown_detection_related_executables: Whether to enable the setting. Upload all unknown detection-related executables for advanced analysis in the cloud.
        :param pulumi.Input[bool] upload_unknown_executables: Whether to enable the setting. Upload all unknown executables for advanced analysis in the cloud.
        """
        if cloud_anti_malware is not None:
            pulumi.set(__self__, "cloud_anti_malware", cloud_anti_malware)
        if custom_blocking is not None:
            pulumi.set(__self__, "custom_blocking", custom_blocking)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if drift_prevention is not None:
            pulumi.set(__self__, "drift_prevention", drift_prevention)
        if email_protocol_visibility is not None:
            pulumi.set(__self__, "email_protocol_visibility", email_protocol_visibility)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if filesystem_visibility is not None:
            pulumi.set(__self__, "filesystem_visibility", filesystem_visibility)
        if ftp_visibility is not None:
            pulumi.set(__self__, "ftp_visibility", ftp_visibility)
        if host_groups is not None:
            pulumi.set(__self__, "host_groups", host_groups)
        if http_visibility is not None:
            pulumi.set(__self__, "http_visibility", http_visibility)
        if ioa_rule_groups is not None:
            pulumi.set(__self__, "ioa_rule_groups", ioa_rule_groups)
        if last_updated is not None:
            pulumi.set(__self__, "last_updated", last_updated)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if network_visibility is not None:
            pulumi.set(__self__, "network_visibility", network_visibility)
        if prevent_suspicious_processes is not None:
            pulumi.set(__self__, "prevent_suspicious_processes", prevent_suspicious_processes)
        if quarantine is not None:
            pulumi.set(__self__, "quarantine", quarantine)
        if script_based_execution_monitoring is not None:
            pulumi.set(__self__, "script_based_execution_monitoring", script_based_execution_monitoring)
        if sensor_anti_malware is not None:
            pulumi.set(__self__, "sensor_anti_malware", sensor_anti_malware)
        if tls_visibility is not None:
            pulumi.set(__self__, "tls_visibility", tls_visibility)
        if upload_unknown_detection_related_executables is not None:
            pulumi.set(__self__, "upload_unknown_detection_related_executables", upload_unknown_detection_related_executables)
        if upload_unknown_executables is not None:
            pulumi.set(__self__, "upload_unknown_executables", upload_unknown_executables)

    @property
    @pulumi.getter(name="cloudAntiMalware")
    def cloud_anti_malware(self) -> Optional[pulumi.Input['PreventionPolicyLinuxCloudAntiMalwareArgs']]:
        """
        Use cloud-based machine learning informed by global analysis of executables to detect and prevent known malware for your online hosts.
        """
        return pulumi.get(self, "cloud_anti_malware")

    @cloud_anti_malware.setter
    def cloud_anti_malware(self, value: Optional[pulumi.Input['PreventionPolicyLinuxCloudAntiMalwareArgs']]):
        pulumi.set(self, "cloud_anti_malware", value)

    @property
    @pulumi.getter(name="customBlocking")
    def custom_blocking(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Block processes matching hashes that you add to IOC Management with the action set to "Block" or "Block, hide detection".
        """
        return pulumi.get(self, "custom_blocking")

    @custom_blocking.setter
    def custom_blocking(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "custom_blocking", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of the prevention policy.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="driftPrevention")
    def drift_prevention(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Block new processes originating from files written in a container. This prevents a container from drifting from its immutable runtime state.
        """
        return pulumi.get(self, "drift_prevention")

    @drift_prevention.setter
    def drift_prevention(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "drift_prevention", value)

    @property
    @pulumi.getter(name="emailProtocolVisibility")
    def email_protocol_visibility(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Allows the sensor to monitor SMTP, IMAP, and POP3 traffic for malicious patterns and improved detections.
        """
        return pulumi.get(self, "email_protocol_visibility")

    @email_protocol_visibility.setter
    def email_protocol_visibility(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "email_protocol_visibility", value)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Enable the prevention policy.
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter(name="filesystemVisibility")
    def filesystem_visibility(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Allows the sensor to monitor filesystem activity for additional telemetry and improved detections.
        """
        return pulumi.get(self, "filesystem_visibility")

    @filesystem_visibility.setter
    def filesystem_visibility(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "filesystem_visibility", value)

    @property
    @pulumi.getter(name="ftpVisibility")
    def ftp_visibility(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Allows the sensor to monitor unencrypted FTP traffic for malicious patterns and improved detections.
        """
        return pulumi.get(self, "ftp_visibility")

    @ftp_visibility.setter
    def ftp_visibility(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ftp_visibility", value)

    @property
    @pulumi.getter(name="hostGroups")
    def host_groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Host Group ids to attach to the prevention policy.
        """
        return pulumi.get(self, "host_groups")

    @host_groups.setter
    def host_groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "host_groups", value)

    @property
    @pulumi.getter(name="httpVisibility")
    def http_visibility(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Allows the sensor to monitor unencrypted HTTP traffic for malicious patterns and improved detections.
        """
        return pulumi.get(self, "http_visibility")

    @http_visibility.setter
    def http_visibility(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "http_visibility", value)

    @property
    @pulumi.getter(name="ioaRuleGroups")
    def ioa_rule_groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        IOA Rule Group to attach to the prevention policy.
        """
        return pulumi.get(self, "ioa_rule_groups")

    @ioa_rule_groups.setter
    def ioa_rule_groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "ioa_rule_groups", value)

    @property
    @pulumi.getter(name="lastUpdated")
    def last_updated(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "last_updated")

    @last_updated.setter
    def last_updated(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "last_updated", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the prevention policy.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="networkVisibility")
    def network_visibility(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Allows the sensor to monitor network activity for additional telemetry and improved detections.
        """
        return pulumi.get(self, "network_visibility")

    @network_visibility.setter
    def network_visibility(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "network_visibility", value)

    @property
    @pulumi.getter(name="preventSuspiciousProcesses")
    def prevent_suspicious_processes(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Block processes that CrowdStrike analysts classify as suspicious. These are focused on dynamic IOAs, such as malware, exploits and other threats.
        """
        return pulumi.get(self, "prevent_suspicious_processes")

    @prevent_suspicious_processes.setter
    def prevent_suspicious_processes(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "prevent_suspicious_processes", value)

    @property
    @pulumi.getter
    def quarantine(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Quarantine executable files after they’re prevented by NGAV. When this is enabled, we recommend setting anti-malware prevention levels to Moderate or higher and not using other antivirus solutions.
        """
        return pulumi.get(self, "quarantine")

    @quarantine.setter
    def quarantine(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "quarantine", value)

    @property
    @pulumi.getter(name="scriptBasedExecutionMonitoring")
    def script_based_execution_monitoring(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Provides visibility into suspicious scripts, including shell and other scripting languages.
        """
        return pulumi.get(self, "script_based_execution_monitoring")

    @script_based_execution_monitoring.setter
    def script_based_execution_monitoring(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "script_based_execution_monitoring", value)

    @property
    @pulumi.getter(name="sensorAntiMalware")
    def sensor_anti_malware(self) -> Optional[pulumi.Input['PreventionPolicyLinuxSensorAntiMalwareArgs']]:
        """
        For offline and online hosts, use sensor-based machine learning to identify and analyze unknown executables as they run to detect and prevent malware.
        """
        return pulumi.get(self, "sensor_anti_malware")

    @sensor_anti_malware.setter
    def sensor_anti_malware(self, value: Optional[pulumi.Input['PreventionPolicyLinuxSensorAntiMalwareArgs']]):
        pulumi.set(self, "sensor_anti_malware", value)

    @property
    @pulumi.getter(name="tlsVisibility")
    def tls_visibility(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Allows the sensor to monitor TLS traffic for malicious patterns and improved detections.
        """
        return pulumi.get(self, "tls_visibility")

    @tls_visibility.setter
    def tls_visibility(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "tls_visibility", value)

    @property
    @pulumi.getter(name="uploadUnknownDetectionRelatedExecutables")
    def upload_unknown_detection_related_executables(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Upload all unknown detection-related executables for advanced analysis in the cloud.
        """
        return pulumi.get(self, "upload_unknown_detection_related_executables")

    @upload_unknown_detection_related_executables.setter
    def upload_unknown_detection_related_executables(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "upload_unknown_detection_related_executables", value)

    @property
    @pulumi.getter(name="uploadUnknownExecutables")
    def upload_unknown_executables(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the setting. Upload all unknown executables for advanced analysis in the cloud.
        """
        return pulumi.get(self, "upload_unknown_executables")

    @upload_unknown_executables.setter
    def upload_unknown_executables(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "upload_unknown_executables", value)


class PreventionPolicyLinux(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cloud_anti_malware: Optional[pulumi.Input[Union['PreventionPolicyLinuxCloudAntiMalwareArgs', 'PreventionPolicyLinuxCloudAntiMalwareArgsDict']]] = None,
                 custom_blocking: Optional[pulumi.Input[bool]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 drift_prevention: Optional[pulumi.Input[bool]] = None,
                 email_protocol_visibility: Optional[pulumi.Input[bool]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 filesystem_visibility: Optional[pulumi.Input[bool]] = None,
                 ftp_visibility: Optional[pulumi.Input[bool]] = None,
                 host_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 http_visibility: Optional[pulumi.Input[bool]] = None,
                 ioa_rule_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network_visibility: Optional[pulumi.Input[bool]] = None,
                 prevent_suspicious_processes: Optional[pulumi.Input[bool]] = None,
                 quarantine: Optional[pulumi.Input[bool]] = None,
                 script_based_execution_monitoring: Optional[pulumi.Input[bool]] = None,
                 sensor_anti_malware: Optional[pulumi.Input[Union['PreventionPolicyLinuxSensorAntiMalwareArgs', 'PreventionPolicyLinuxSensorAntiMalwareArgsDict']]] = None,
                 tls_visibility: Optional[pulumi.Input[bool]] = None,
                 upload_unknown_detection_related_executables: Optional[pulumi.Input[bool]] = None,
                 upload_unknown_executables: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        """
        This resource allows you to manage CrowdStrike Falcon prevention policies for Linux hosts. Prevention policies allow you to manage what activity will trigger detections and preventions on your hosts.

        ## API Scopes

        The following API scopes are required:

        - Prevention policies | Read & Write

        ## Example Usage

        ```python
        import pulumi
        import crowdstrike_pulumi as crowdstrike

        example = crowdstrike.PreventionPolicyLinux("example",
            enabled=True,
            description="Made with Pulumi",
            host_groups=["d6e3c1e1b3d0467da0fowc96a5e6ecb5"],
            ioa_rule_groups=["ed334b3243bc4b6bb8e7d40a2ecd86fa"],
            cloud_anti_malware={
                "detection": "MODERATE",
                "prevention": "CAUTIOUS",
            },
            sensor_anti_malware={
                "detection": "MODERATE",
                "prevention": "CAUTIOUS",
            },
            quarantine=True,
            custom_blocking=True,
            prevent_suspicious_processes=True,
            script_based_execution_monitoring=True,
            upload_unknown_executables=True,
            upload_unknown_detection_related_executables=True,
            drift_prevention=True,
            email_protocol_visibility=True,
            filesystem_visibility=True,
            ftp_visibility=True,
            http_visibility=True,
            network_visibility=True,
            tls_visibility=True)
        pulumi.export("preventionPolicyLinux", example)
        ```

        ## Import

        prevention policy can be imported by specifying the policy id.

        ```sh
        $ pulumi import crowdstrike:index/preventionPolicyLinux:PreventionPolicyLinux example 7fb858a949034a0cbca175f660f1e769
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['PreventionPolicyLinuxCloudAntiMalwareArgs', 'PreventionPolicyLinuxCloudAntiMalwareArgsDict']] cloud_anti_malware: Use cloud-based machine learning informed by global analysis of executables to detect and prevent known malware for your online hosts.
        :param pulumi.Input[bool] custom_blocking: Whether to enable the setting. Block processes matching hashes that you add to IOC Management with the action set to "Block" or "Block, hide detection".
        :param pulumi.Input[str] description: Description of the prevention policy.
        :param pulumi.Input[bool] drift_prevention: Whether to enable the setting. Block new processes originating from files written in a container. This prevents a container from drifting from its immutable runtime state.
        :param pulumi.Input[bool] email_protocol_visibility: Whether to enable the setting. Allows the sensor to monitor SMTP, IMAP, and POP3 traffic for malicious patterns and improved detections.
        :param pulumi.Input[bool] enabled: Enable the prevention policy.
        :param pulumi.Input[bool] filesystem_visibility: Whether to enable the setting. Allows the sensor to monitor filesystem activity for additional telemetry and improved detections.
        :param pulumi.Input[bool] ftp_visibility: Whether to enable the setting. Allows the sensor to monitor unencrypted FTP traffic for malicious patterns and improved detections.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_groups: Host Group ids to attach to the prevention policy.
        :param pulumi.Input[bool] http_visibility: Whether to enable the setting. Allows the sensor to monitor unencrypted HTTP traffic for malicious patterns and improved detections.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ioa_rule_groups: IOA Rule Group to attach to the prevention policy.
        :param pulumi.Input[str] name: Name of the prevention policy.
        :param pulumi.Input[bool] network_visibility: Whether to enable the setting. Allows the sensor to monitor network activity for additional telemetry and improved detections.
        :param pulumi.Input[bool] prevent_suspicious_processes: Whether to enable the setting. Block processes that CrowdStrike analysts classify as suspicious. These are focused on dynamic IOAs, such as malware, exploits and other threats.
        :param pulumi.Input[bool] quarantine: Whether to enable the setting. Quarantine executable files after they’re prevented by NGAV. When this is enabled, we recommend setting anti-malware prevention levels to Moderate or higher and not using other antivirus solutions.
        :param pulumi.Input[bool] script_based_execution_monitoring: Whether to enable the setting. Provides visibility into suspicious scripts, including shell and other scripting languages.
        :param pulumi.Input[Union['PreventionPolicyLinuxSensorAntiMalwareArgs', 'PreventionPolicyLinuxSensorAntiMalwareArgsDict']] sensor_anti_malware: For offline and online hosts, use sensor-based machine learning to identify and analyze unknown executables as they run to detect and prevent malware.
        :param pulumi.Input[bool] tls_visibility: Whether to enable the setting. Allows the sensor to monitor TLS traffic for malicious patterns and improved detections.
        :param pulumi.Input[bool] upload_unknown_detection_related_executables: Whether to enable the setting. Upload all unknown detection-related executables for advanced analysis in the cloud.
        :param pulumi.Input[bool] upload_unknown_executables: Whether to enable the setting. Upload all unknown executables for advanced analysis in the cloud.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[PreventionPolicyLinuxArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource allows you to manage CrowdStrike Falcon prevention policies for Linux hosts. Prevention policies allow you to manage what activity will trigger detections and preventions on your hosts.

        ## API Scopes

        The following API scopes are required:

        - Prevention policies | Read & Write

        ## Example Usage

        ```python
        import pulumi
        import crowdstrike_pulumi as crowdstrike

        example = crowdstrike.PreventionPolicyLinux("example",
            enabled=True,
            description="Made with Pulumi",
            host_groups=["d6e3c1e1b3d0467da0fowc96a5e6ecb5"],
            ioa_rule_groups=["ed334b3243bc4b6bb8e7d40a2ecd86fa"],
            cloud_anti_malware={
                "detection": "MODERATE",
                "prevention": "CAUTIOUS",
            },
            sensor_anti_malware={
                "detection": "MODERATE",
                "prevention": "CAUTIOUS",
            },
            quarantine=True,
            custom_blocking=True,
            prevent_suspicious_processes=True,
            script_based_execution_monitoring=True,
            upload_unknown_executables=True,
            upload_unknown_detection_related_executables=True,
            drift_prevention=True,
            email_protocol_visibility=True,
            filesystem_visibility=True,
            ftp_visibility=True,
            http_visibility=True,
            network_visibility=True,
            tls_visibility=True)
        pulumi.export("preventionPolicyLinux", example)
        ```

        ## Import

        prevention policy can be imported by specifying the policy id.

        ```sh
        $ pulumi import crowdstrike:index/preventionPolicyLinux:PreventionPolicyLinux example 7fb858a949034a0cbca175f660f1e769
        ```

        :param str resource_name: The name of the resource.
        :param PreventionPolicyLinuxArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(PreventionPolicyLinuxArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cloud_anti_malware: Optional[pulumi.Input[Union['PreventionPolicyLinuxCloudAntiMalwareArgs', 'PreventionPolicyLinuxCloudAntiMalwareArgsDict']]] = None,
                 custom_blocking: Optional[pulumi.Input[bool]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 drift_prevention: Optional[pulumi.Input[bool]] = None,
                 email_protocol_visibility: Optional[pulumi.Input[bool]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 filesystem_visibility: Optional[pulumi.Input[bool]] = None,
                 ftp_visibility: Optional[pulumi.Input[bool]] = None,
                 host_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 http_visibility: Optional[pulumi.Input[bool]] = None,
                 ioa_rule_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network_visibility: Optional[pulumi.Input[bool]] = None,
                 prevent_suspicious_processes: Optional[pulumi.Input[bool]] = None,
                 quarantine: Optional[pulumi.Input[bool]] = None,
                 script_based_execution_monitoring: Optional[pulumi.Input[bool]] = None,
                 sensor_anti_malware: Optional[pulumi.Input[Union['PreventionPolicyLinuxSensorAntiMalwareArgs', 'PreventionPolicyLinuxSensorAntiMalwareArgsDict']]] = None,
                 tls_visibility: Optional[pulumi.Input[bool]] = None,
                 upload_unknown_detection_related_executables: Optional[pulumi.Input[bool]] = None,
                 upload_unknown_executables: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = PreventionPolicyLinuxArgs.__new__(PreventionPolicyLinuxArgs)

            __props__.__dict__["cloud_anti_malware"] = cloud_anti_malware
            __props__.__dict__["custom_blocking"] = custom_blocking
            __props__.__dict__["description"] = description
            __props__.__dict__["drift_prevention"] = drift_prevention
            __props__.__dict__["email_protocol_visibility"] = email_protocol_visibility
            __props__.__dict__["enabled"] = enabled
            __props__.__dict__["filesystem_visibility"] = filesystem_visibility
            __props__.__dict__["ftp_visibility"] = ftp_visibility
            __props__.__dict__["host_groups"] = host_groups
            __props__.__dict__["http_visibility"] = http_visibility
            __props__.__dict__["ioa_rule_groups"] = ioa_rule_groups
            __props__.__dict__["name"] = name
            __props__.__dict__["network_visibility"] = network_visibility
            __props__.__dict__["prevent_suspicious_processes"] = prevent_suspicious_processes
            __props__.__dict__["quarantine"] = quarantine
            __props__.__dict__["script_based_execution_monitoring"] = script_based_execution_monitoring
            __props__.__dict__["sensor_anti_malware"] = sensor_anti_malware
            __props__.__dict__["tls_visibility"] = tls_visibility
            __props__.__dict__["upload_unknown_detection_related_executables"] = upload_unknown_detection_related_executables
            __props__.__dict__["upload_unknown_executables"] = upload_unknown_executables
            __props__.__dict__["last_updated"] = None
        super(PreventionPolicyLinux, __self__).__init__(
            'crowdstrike:index/preventionPolicyLinux:PreventionPolicyLinux',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            cloud_anti_malware: Optional[pulumi.Input[Union['PreventionPolicyLinuxCloudAntiMalwareArgs', 'PreventionPolicyLinuxCloudAntiMalwareArgsDict']]] = None,
            custom_blocking: Optional[pulumi.Input[bool]] = None,
            description: Optional[pulumi.Input[str]] = None,
            drift_prevention: Optional[pulumi.Input[bool]] = None,
            email_protocol_visibility: Optional[pulumi.Input[bool]] = None,
            enabled: Optional[pulumi.Input[bool]] = None,
            filesystem_visibility: Optional[pulumi.Input[bool]] = None,
            ftp_visibility: Optional[pulumi.Input[bool]] = None,
            host_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            http_visibility: Optional[pulumi.Input[bool]] = None,
            ioa_rule_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            last_updated: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            network_visibility: Optional[pulumi.Input[bool]] = None,
            prevent_suspicious_processes: Optional[pulumi.Input[bool]] = None,
            quarantine: Optional[pulumi.Input[bool]] = None,
            script_based_execution_monitoring: Optional[pulumi.Input[bool]] = None,
            sensor_anti_malware: Optional[pulumi.Input[Union['PreventionPolicyLinuxSensorAntiMalwareArgs', 'PreventionPolicyLinuxSensorAntiMalwareArgsDict']]] = None,
            tls_visibility: Optional[pulumi.Input[bool]] = None,
            upload_unknown_detection_related_executables: Optional[pulumi.Input[bool]] = None,
            upload_unknown_executables: Optional[pulumi.Input[bool]] = None) -> 'PreventionPolicyLinux':
        """
        Get an existing PreventionPolicyLinux resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['PreventionPolicyLinuxCloudAntiMalwareArgs', 'PreventionPolicyLinuxCloudAntiMalwareArgsDict']] cloud_anti_malware: Use cloud-based machine learning informed by global analysis of executables to detect and prevent known malware for your online hosts.
        :param pulumi.Input[bool] custom_blocking: Whether to enable the setting. Block processes matching hashes that you add to IOC Management with the action set to "Block" or "Block, hide detection".
        :param pulumi.Input[str] description: Description of the prevention policy.
        :param pulumi.Input[bool] drift_prevention: Whether to enable the setting. Block new processes originating from files written in a container. This prevents a container from drifting from its immutable runtime state.
        :param pulumi.Input[bool] email_protocol_visibility: Whether to enable the setting. Allows the sensor to monitor SMTP, IMAP, and POP3 traffic for malicious patterns and improved detections.
        :param pulumi.Input[bool] enabled: Enable the prevention policy.
        :param pulumi.Input[bool] filesystem_visibility: Whether to enable the setting. Allows the sensor to monitor filesystem activity for additional telemetry and improved detections.
        :param pulumi.Input[bool] ftp_visibility: Whether to enable the setting. Allows the sensor to monitor unencrypted FTP traffic for malicious patterns and improved detections.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_groups: Host Group ids to attach to the prevention policy.
        :param pulumi.Input[bool] http_visibility: Whether to enable the setting. Allows the sensor to monitor unencrypted HTTP traffic for malicious patterns and improved detections.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ioa_rule_groups: IOA Rule Group to attach to the prevention policy.
        :param pulumi.Input[str] name: Name of the prevention policy.
        :param pulumi.Input[bool] network_visibility: Whether to enable the setting. Allows the sensor to monitor network activity for additional telemetry and improved detections.
        :param pulumi.Input[bool] prevent_suspicious_processes: Whether to enable the setting. Block processes that CrowdStrike analysts classify as suspicious. These are focused on dynamic IOAs, such as malware, exploits and other threats.
        :param pulumi.Input[bool] quarantine: Whether to enable the setting. Quarantine executable files after they’re prevented by NGAV. When this is enabled, we recommend setting anti-malware prevention levels to Moderate or higher and not using other antivirus solutions.
        :param pulumi.Input[bool] script_based_execution_monitoring: Whether to enable the setting. Provides visibility into suspicious scripts, including shell and other scripting languages.
        :param pulumi.Input[Union['PreventionPolicyLinuxSensorAntiMalwareArgs', 'PreventionPolicyLinuxSensorAntiMalwareArgsDict']] sensor_anti_malware: For offline and online hosts, use sensor-based machine learning to identify and analyze unknown executables as they run to detect and prevent malware.
        :param pulumi.Input[bool] tls_visibility: Whether to enable the setting. Allows the sensor to monitor TLS traffic for malicious patterns and improved detections.
        :param pulumi.Input[bool] upload_unknown_detection_related_executables: Whether to enable the setting. Upload all unknown detection-related executables for advanced analysis in the cloud.
        :param pulumi.Input[bool] upload_unknown_executables: Whether to enable the setting. Upload all unknown executables for advanced analysis in the cloud.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _PreventionPolicyLinuxState.__new__(_PreventionPolicyLinuxState)

        __props__.__dict__["cloud_anti_malware"] = cloud_anti_malware
        __props__.__dict__["custom_blocking"] = custom_blocking
        __props__.__dict__["description"] = description
        __props__.__dict__["drift_prevention"] = drift_prevention
        __props__.__dict__["email_protocol_visibility"] = email_protocol_visibility
        __props__.__dict__["enabled"] = enabled
        __props__.__dict__["filesystem_visibility"] = filesystem_visibility
        __props__.__dict__["ftp_visibility"] = ftp_visibility
        __props__.__dict__["host_groups"] = host_groups
        __props__.__dict__["http_visibility"] = http_visibility
        __props__.__dict__["ioa_rule_groups"] = ioa_rule_groups
        __props__.__dict__["last_updated"] = last_updated
        __props__.__dict__["name"] = name
        __props__.__dict__["network_visibility"] = network_visibility
        __props__.__dict__["prevent_suspicious_processes"] = prevent_suspicious_processes
        __props__.__dict__["quarantine"] = quarantine
        __props__.__dict__["script_based_execution_monitoring"] = script_based_execution_monitoring
        __props__.__dict__["sensor_anti_malware"] = sensor_anti_malware
        __props__.__dict__["tls_visibility"] = tls_visibility
        __props__.__dict__["upload_unknown_detection_related_executables"] = upload_unknown_detection_related_executables
        __props__.__dict__["upload_unknown_executables"] = upload_unknown_executables
        return PreventionPolicyLinux(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="cloudAntiMalware")
    def cloud_anti_malware(self) -> pulumi.Output['outputs.PreventionPolicyLinuxCloudAntiMalware']:
        """
        Use cloud-based machine learning informed by global analysis of executables to detect and prevent known malware for your online hosts.
        """
        return pulumi.get(self, "cloud_anti_malware")

    @property
    @pulumi.getter(name="customBlocking")
    def custom_blocking(self) -> pulumi.Output[bool]:
        """
        Whether to enable the setting. Block processes matching hashes that you add to IOC Management with the action set to "Block" or "Block, hide detection".
        """
        return pulumi.get(self, "custom_blocking")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        Description of the prevention policy.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="driftPrevention")
    def drift_prevention(self) -> pulumi.Output[bool]:
        """
        Whether to enable the setting. Block new processes originating from files written in a container. This prevents a container from drifting from its immutable runtime state.
        """
        return pulumi.get(self, "drift_prevention")

    @property
    @pulumi.getter(name="emailProtocolVisibility")
    def email_protocol_visibility(self) -> pulumi.Output[bool]:
        """
        Whether to enable the setting. Allows the sensor to monitor SMTP, IMAP, and POP3 traffic for malicious patterns and improved detections.
        """
        return pulumi.get(self, "email_protocol_visibility")

    @property
    @pulumi.getter
    def enabled(self) -> pulumi.Output[bool]:
        """
        Enable the prevention policy.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter(name="filesystemVisibility")
    def filesystem_visibility(self) -> pulumi.Output[bool]:
        """
        Whether to enable the setting. Allows the sensor to monitor filesystem activity for additional telemetry and improved detections.
        """
        return pulumi.get(self, "filesystem_visibility")

    @property
    @pulumi.getter(name="ftpVisibility")
    def ftp_visibility(self) -> pulumi.Output[bool]:
        """
        Whether to enable the setting. Allows the sensor to monitor unencrypted FTP traffic for malicious patterns and improved detections.
        """
        return pulumi.get(self, "ftp_visibility")

    @property
    @pulumi.getter(name="hostGroups")
    def host_groups(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        Host Group ids to attach to the prevention policy.
        """
        return pulumi.get(self, "host_groups")

    @property
    @pulumi.getter(name="httpVisibility")
    def http_visibility(self) -> pulumi.Output[bool]:
        """
        Whether to enable the setting. Allows the sensor to monitor unencrypted HTTP traffic for malicious patterns and improved detections.
        """
        return pulumi.get(self, "http_visibility")

    @property
    @pulumi.getter(name="ioaRuleGroups")
    def ioa_rule_groups(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        IOA Rule Group to attach to the prevention policy.
        """
        return pulumi.get(self, "ioa_rule_groups")

    @property
    @pulumi.getter(name="lastUpdated")
    def last_updated(self) -> pulumi.Output[str]:
        return pulumi.get(self, "last_updated")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Name of the prevention policy.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="networkVisibility")
    def network_visibility(self) -> pulumi.Output[bool]:
        """
        Whether to enable the setting. Allows the sensor to monitor network activity for additional telemetry and improved detections.
        """
        return pulumi.get(self, "network_visibility")

    @property
    @pulumi.getter(name="preventSuspiciousProcesses")
    def prevent_suspicious_processes(self) -> pulumi.Output[bool]:
        """
        Whether to enable the setting. Block processes that CrowdStrike analysts classify as suspicious. These are focused on dynamic IOAs, such as malware, exploits and other threats.
        """
        return pulumi.get(self, "prevent_suspicious_processes")

    @property
    @pulumi.getter
    def quarantine(self) -> pulumi.Output[bool]:
        """
        Whether to enable the setting. Quarantine executable files after they’re prevented by NGAV. When this is enabled, we recommend setting anti-malware prevention levels to Moderate or higher and not using other antivirus solutions.
        """
        return pulumi.get(self, "quarantine")

    @property
    @pulumi.getter(name="scriptBasedExecutionMonitoring")
    def script_based_execution_monitoring(self) -> pulumi.Output[bool]:
        """
        Whether to enable the setting. Provides visibility into suspicious scripts, including shell and other scripting languages.
        """
        return pulumi.get(self, "script_based_execution_monitoring")

    @property
    @pulumi.getter(name="sensorAntiMalware")
    def sensor_anti_malware(self) -> pulumi.Output['outputs.PreventionPolicyLinuxSensorAntiMalware']:
        """
        For offline and online hosts, use sensor-based machine learning to identify and analyze unknown executables as they run to detect and prevent malware.
        """
        return pulumi.get(self, "sensor_anti_malware")

    @property
    @pulumi.getter(name="tlsVisibility")
    def tls_visibility(self) -> pulumi.Output[bool]:
        """
        Whether to enable the setting. Allows the sensor to monitor TLS traffic for malicious patterns and improved detections.
        """
        return pulumi.get(self, "tls_visibility")

    @property
    @pulumi.getter(name="uploadUnknownDetectionRelatedExecutables")
    def upload_unknown_detection_related_executables(self) -> pulumi.Output[bool]:
        """
        Whether to enable the setting. Upload all unknown detection-related executables for advanced analysis in the cloud.
        """
        return pulumi.get(self, "upload_unknown_detection_related_executables")

    @property
    @pulumi.getter(name="uploadUnknownExecutables")
    def upload_unknown_executables(self) -> pulumi.Output[bool]:
        """
        Whether to enable the setting. Upload all unknown executables for advanced analysis in the cloud.
        """
        return pulumi.get(self, "upload_unknown_executables")

